/* javascript for bpp3 */
/* <--- Copyright Bruce Rannala, University of California Davis, 2015 ---> */

fs = require('fs');
nexusParser = require('./parserNexus')
 
var seqInFileString=[];
var seqInArray;
var seqInFile2;
var allData=[];




$(function() {

ctlFilename = "empty";

// global variables for preferences

var seqColor="seqboxWhiteOnBlack";
var bppColor="bppYellowOnBlack";
var bppPath="";


$( "#results" ).accordion({
      heightStyle: "fill"
});
$( "#results" ).accordion({
  header: "h3"
});
// $( "#results" ).accordion("refresh");


// Preferences menu

 function chooseDir(name) {
    var chooser = document.querySelector(name);
    chooser.addEventListener("change", function(evt) {
      wdName=this.value + '/';
      $( "#cwdName" ).val(wdName);
      fillControlFile();
      $( "#dataProvOut" ).replaceWith("<input style='margin: 4px' id='dataProvOut' type='file' nwsaveas='" + wdName + "bpp.prv' />");
      $( "#outputmcmcfile" ).replaceWith("<input style='margin: 4px' id='outputmcmcfile' type='file' nwsaveas='" + wdName + "mcmc.txt' />");
      $( "#outputresultsfile" ).replaceWith("<input style='margin: 4px' id='outputresultsfile' type='file' nwsaveas='" + wdName + "out.txt' />");
      getMCMCFilePath();
      getOutFilePath();
      getDPFilePath();
    }, false);
    chooser.click();
  }

$( "#getwd" ).button()
$( "#getwd" ).click( function(evt) {
chooseDir('#dirDialog');
});

$( "#SDcolors" ).buttonset()

$( "#seqredblack" ).click(function() {
    seqColor = "seqboxRedOnBlack";
});

$( "#seqbluewhite" ).click(function() {
    seqColor = "seqboxBlueOnWhite";
});

$( "#seqwhiteblue" ).click(function() {
    seqColor = "seqboxWhiteOnBlue";
});

$( "#seqwhiteblack" ).click(function() {
    seqColor = "seqboxWhiteOnBlack";
});

$( "#BPPScolors" ).buttonset()

$( "#bppyellowblack" ).click(function() {
    $( "#bppout" ).removeClass();
    $( "#bppout" ).addClass('bppYellowOnBlack');
    seqColor = "bppYellowOnBlack";
});

$( "#bppbluewhite" ).click(function() {
    $( "#bppout" ).removeClass();
    $( "#bppout" ).addClass('bppBlueOnWhite');
    seqColor = "bppBlueOnWhite";
});

$( "#bppwhiteblue" ).click(function() {
    $( "#bppout" ).removeClass();
    $( "#bppout" ).addClass('bppWhiteOnBlue');
    seqColor = "bppWhiteOnBlue";
});

$( "#bppwhiteblack" ).click(function() {
    $( "#bppout" ).removeClass();
    $( "#bppout" ).addClass('bppWhiteOnBlack');
    seqColor = "bppWhiteOnBlack";
});

// sequence data manipulation functions
var i2;
function getSeqFile(){
     $('#seqInput').change(function () {
     seqInFile2=$('#seqInput').val();
     seqInFileString = seqInFile2.split(";");
     for(i2=0; i2<seqInFileString.length; i2++)
         {
            getSeqData(i2,seqInFileString); 
         }
       });
}

function getSeqData(i2,seqInFileString)
    {
   fs.readFile(seqInFileString[i2], 'utf-8', function (error, contents) {
         try{
            var seqInFileStr2 = contents;
            if(seqInFileStr2.match(/#NEXUS/i)==null)
                throw { name: 'File Reading Error', message: 'is not a NEXUS format file.' };
            else
            {
                gLocusIndex += 1;
                allData[gLocusIndex]=nexusParser.parse(seqInFileStr2.replace(/\s*\[.*?\]\s*/g,'\n'));
                allData[gLocusIndex].linclude=false;
                var locusData = [];
                var id0 = "title" + gLocusIndex;
                var id1 = "imploc" + gLocusIndex;
                var id2 = "locus" + gLocusIndex;
                var id3 = "delbox" + gLocusIndex;
                var id4 = "incbox" + gLocusIndex;
                var s1 = seqInFileString[i2].split("/")[seqInFileString[i2].split("/").length-1];
                var locName = s1;
                allData[gLocusIndex].lName=s1;
                var titvar= "<h3 id='" + id0 + "'></h3>";
                $( "#accordion" ).append($(titvar).text(locName));
                var idvar = "<div id=" + id1 + "></div>";
                $( "#accordion" ).append($(idvar).text(" "));
                var str1 = "<input type=button style='margin: 4px' id='delbox" + gLocusIndex + "' value='Delete Alignments' class='deletebox'>";
                var str2 = "<label></label>";
                var str3 = "<input type='checkbox' id='incbox" + gLocusIndex + "' style='margin: 4px' >";
                var id1h = "#" + id1;
                var id4h = "#" + id4;
                $(id1h).append($(str1).text(" "));
                $(id1h).append($(str2).text("Attach alignments to BPP sequence file:"));
                $(id1h).append($(str3).text(" "));
                    
                $(id1h).append(" Sequence length: "+ allData[gLocusIndex].nsite + "bp. Sequence number: " + allData[gLocusIndex].ntaxa);
                var str4 = "<textarea readonly id='" + id2 + "' class='" + seqColor + "' wrap='off' label='sequenceBox' cols=92  rows=12 ></textarea>";
                $( id1h ).append($(str4).text(" "));
                $( "#accordion" ).accordion("refresh");
             }

            // get concensus sequence
             var conSeq="";
             for(i=0; i<allData[gLocusIndex].nsite; i++)
             {
                 var noPm=true;
                 for(j=1; j<allData[gLocusIndex].ntaxa; j++)
                     if((allData[gLocusIndex].data.sequences[j-1][i] != allData[gLocusIndex].data.sequences[j][i])&&
                       (allData[gLocusIndex].data.sequences[j-1][i]!=allData[gLocusIndex].missing)&&
                       (allData[gLocusIndex].data.sequences[j-1][i]!=allData[gLocusIndex].gap)&&
                       (allData[gLocusIndex].data.sequences[j][i]!=allData[gLocusIndex].missing)&&
                       (allData[gLocusIndex].data.sequences[j][i]!=allData[gLocusIndex].gap))
                        noPm=false;
                 if(noPm==false)
                     conSeq+='*';
                 else
                 { conSeq+=' '; }
             }
             allData[gLocusIndex].concensus=conSeq;
             i=0;
             var SFstring="";
             SFstring += "                    " + conSeq + "\n";
             for(i=0; i<allData[gLocusIndex].ntaxa; i++)
                 {
                    SFstring += allData[gLocusIndex].data.indNamesSeq[i];
                    for(var j=1;j<=(20-allData[gLocusIndex].data.indNamesSeq[i].length); j++)
                        SFstring += " ";
                        SFstring += allData[gLocusIndex].data.sequences[i] + "\n";
                 }
             $( id4h ).on("click",function() {
                var arrayIndex = id4h.match(/\d+/);
                if(allData[arrayIndex].linclude==false)
                {
                    allData[arrayIndex].linclude=true;
                    noSeqFilesOpen+=1;
                }
                else
                {
                    allData[arrayIndex].linclude=false;
                    noSeqFilesOpen-=1;
                }
                if(noSeqFilesOpen==1)
                {
                 $( "#warn_no_sf" ).addClass('not');
                 $( "#saveseqfile" ).removeClass('not');
                }
                 if(noSeqFilesOpen==0)
                 {
                    $( "#warn_no_sf" ).removeClass('not');
                    $( "#saveseqfile" ).addClass('not');
                 }
                 refreshLocusList();
                 refreshSeqLst();
                 fillSeqNames();
               });
             var newTit="#" + id0;
             var newLoc="#" + id2;
             var newDel="#" + id3;
             $( newLoc ).val(SFstring);
            $( newDel ).button()
            $( newDel ).click( function() {
                 var arrayIndex = newTit.match(/\d+/);
                $( id1h ).remove();
                $( newTit ).remove();
                $( "#idmap tbody tr" ).remove();
                if(allData[arrayIndex].linclude==true)
                    noSeqFilesOpen-=1;
                if(noSeqFilesOpen==0)
                {
                    $( "#warn_no_sf" ).removeClass('not');
                    $( "#saveseqfile" ).addClass('not');
                }
                delete allData[arrayIndex];
                refreshLocusList();
                refreshSeqLst();
                fillSeqNames();
                $( "#accordion" ).accordion("refresh");
             });
    } catch(ex) {  alert(ex.name + ": \n" + ex.message); }
         }
         );
}
       

function refreshLocusList(){
    var locLst = "";
    for(var j=1; j<=allData.length; j++)
        if((j in allData)&&(allData[j].linclude==true))
        {
            locLst += allData[j].lName + "\n";
        }
        $( "#idmap tbody tr" ).remove();
        $( "#selectedloci" ).val(locLst);
}

function compare(a,b) {
  if (a.indName < b.indName)
     return -1;
  if (a.indName > b.indName)
    return 1;
  return 0;
}

function refreshSeqLst(){
        seqLst=[];
        for(var i=1; i<=allData.length; i++)
        {
            if((i in allData)&&(allData[i].linclude==true))
                for(var j=0; j<allData[i].data.indNamesSeq.length; j++)

                    if(seqLst.map(function(e) { return e.indName; }).indexOf(allData[i].data.indNamesSeq[j]) < 0)
                    {
                        seqLst.push({indName: allData[i].data.indNamesSeq[j], popName: "Unassigned"});
                     }
        }
        for(var i=0; i<popNames.length; i++)
        {
            popNames[i].noSeq=0;
            $('#popmap tr').eq(i+1).find('td').eq(1).text("0");
        }
        seqLst.sort(compare);
}


function bppSeqOutFile(){
     $( "#bppseqoutfile" ).change(function () {
         if(mapRead)
         {
         seqfile=$('#bppseqoutfile').val();
         var s1="";
         for(var j=1; j<allData.length; j++)
                    if((j in allData)&&(allData[j].linclude==true))
                    {
                        s1+= "\n\n" + "        " + allData[j].ntaxa + "        " + allData[j].nsite + "\n\n";
                        var c=allData[j].data.indNamesSeq.length;
                        for(var k=0; k<c; k++)
                        {
                            if(indivToPop[seqLst.map(function(e) { return e.indName; }).indexOf(allData[j].data.indNamesSeq[k])]!=undefined)
                            {
                                s1+= indivToPop[seqLst.map(function(e) { return e.indName; }).indexOf(allData[j].data.indNamesSeq[k])]
                                + "^" + seqLst.map(function(e) {
                                    return e.indName; }).indexOf(allData[j].data.indNamesSeq[k]) +  "        "
                                + allData[j].data.sequences[k] + "\n";
                            }
                            else
                                alert("Sequence labeled " + indivToPop[allData[j].data.indNamesSeq[k]] + " is not in map file!");
                        }
                    }
         fs.writeFile(seqfile, s1, function (err) {
         if (err) return console.log(err);
});
         }
         else
             alert("No Map file specified, cannot create sequence file!");
 });
}

var indivToPop={};
var mapRead=false;

function bppMapInFile(){
$( "#mapinfile" ).change(function () {
    var mapInFile=$('#mapinfile').val();
    var mapFileContents="";
    var mapArray=[];
    fs.readFile(mapInFile,'utf-8',function(error,contents)
    {
        mapFileContents=contents;
        mapArray=mapFileContents.match(/[^\r\n]+/g);
        for(var i3=0;i3<mapArray.length;i3++)
        { 
            var e1=mapArray[i3].match(/\w+/g)[0];
            var e2=mapArray[i3].match(/\w+/g)[1];
            indivToPop[e1]=e2;
        }
    }
               );    
mapRead=true;
});
}


function addSeqName(seqName,popName) {
    var myRow = "<tr><td class='seqNm'>" + seqName + "</td><td>" + popName + "</td></tr>";
    $("#idmap tbody:first").append(myRow);
 }

var pos=0;
var posOrig=0;
var posNew=0;

function fillSeqNames() {
    for(var j=0; j<seqLst.length; j++)
        addSeqName(seqLst[j].indName,seqLst[j].popName);
    $( ".seqNm" ).click(function(){
        if(firstRow==false)
        {
        pos = seqLst.map(function(e) { return e.indName; }).indexOf($(this).text());
        if(seqLst[pos].popName!="Unassigned")
        {
            posOrig = popNames.map(function(e) { return e.name; }).indexOf(seqLst[pos].popName);
             popNames[posOrig].noSeq-=1;
            $('#popmap tr').eq(posOrig+1).find('td').eq(1).text(popNames[posOrig].noSeq);

            posNew = popNames.map(function(e) { return e.name; }).indexOf(currPop);
            popNames[posNew].noSeq+=1;
            $('#popmap tr').eq(posNew+1).find('td').eq(1).text(popNames[posNew].noSeq);
            $(this).closest("td").next().text(currPop);
        }
        else
        {
            seqLst[pos].popName=currPop;
            $(this).closest("td").next().text(currPop);
            posNew = popNames.map(function(e) { return e.name; }).indexOf(currPop);
            popNames[posNew].noSeq+=1;
            $('#popmap tr').eq(posNew+1).find('td').eq(1).text(popNames[posNew].noSeq);

        }

        }
        sumIndivs=0;
        for(var i=0; i<popNames.length; i++)
            sumIndivs += popNames[i].noSeq;
        if(sumIndivs == seqLst.length)
            $( "#mapoutfile" ).removeClass('not');
    });
}


function bppMapOutFile(){
     $( "#mapout" ).change(function () {
         mapOutFileNm=$('#mapout').val();
         fs = require('fs');
         var s1="";
         for(var j=0; j<seqLst.length; j++)
                s1 += j + "  " + seqLst[j].popName + "\n";
         fs.writeFile(mapOutFileNm, s1, function (err) {
         if (err) return console.log(err);
         });
});
}

getSeqFile();
bppSeqOutFile();
bppMapOutFile();
bppMapInFile();

$( "#popnameBox" ).text()

$( "#popNameButton" ).button()

$( "#popNameButton" ).click( function(evt) {
    popNames.push({name: $( "#popnameBox" ).val(), noSeq: 0});
    var myRow = "<tr><td class='popNm'>" + $( "#popnameBox" ).val() + "</td><td>0</td></tr>";
    $("#popmap tbody:last").append(myRow);
    if(firstRow)
    {
        $('#popmap tr').eq(1).find('td').eq(0).addClass("popSelected");
        currPop=$('#popmap tr').eq(1).find('td').eq(0).text();
        firstRow=false;
    }

    $( ".popNm" ).click(function(){
        $( "#popmap td" ).removeClass("popSelected");
        currPop=$(this).text();
        $(this).addClass("popSelected");
});
});


// functions for running bpp

function scrollToBottom() {
   $('#bppout').scrollTop($('#bppout')[0].scrollHeight);
}

function getCtlFilePath(){
     $('#ctlinput').change(function () {
         $( "#runbpp" ).removeClass('not');
         ctlFilename=$('#ctlinput').val();
     });
}

getCtlFilePath();

var startTime;
var endTime;
var gui = require('nw.gui');
// var out;
// var err;

$( "#runbpp" ).click( function(evt) {

startTime = new Date();

var out = fs.openSync(gui.App.dataPath+'/out.log', 'w');
var err = fs.openSync(gui.App.dataPath+'/out.log', 'w');

var cp = require('child_process');
var child = cp.spawn('./bpp_SSE', [ctlFilename],
                     { detached: true, stdio: [ 'ignore', out, err ] });
try{
$( "#runbpp" ).addClass('not');
$( "#killbpp" ).removeClass('not');

$( "#killbpp" ).click( function(evt) {
 // send SIGHUP to process
child.kill('SIGHUP');
});

child.on('exit', function (code,signal) {
    endTime = new Date();
	fs.readFile(gui.App.dataPath+'/out.log', 'utf-8', function (error, contents) {$('#bppout').val(contents);
    scrollToBottom();
    $( "#killbpp" ).addClass('not');
    $( "#runbpp" ).removeClass('not');
    clearInterval(int1);
    if(signal != 'SIGHUP')
        addDataProvenance();
    });
});

var int1 = null;
int1 = setInterval(function() { fs.readFile(gui.App.dataPath+'/out.log', 'utf-8', function (error, contents)
    {$('#bppout').val(contents);
    scrollToBottom();
});}, 1000);
}
catch(error)
{
    alert("error running bpp");
}
});

fillControlFile();

// functions for summarizing results

function getCtl2FilePath(){
     $('#ctl2input').change(function () {
         var ctl2Filename=$('#ctl2input').val();
         var ctrFileContents = "";
         var ctlArray = [];
         var speciestree=[];
         var speciesdelim=[];
         fs.readFile(ctl2Filename, 'utf-8', function (error, contents) {
         try{
         if(error) throw error;
         ctlFileContents = contents;
         ctlArray=ctlFileContents.match(/[^\r\n]+/g);
         for(var i=0; i<ctlArray.length; i++)
             {
                ctlArray[i]=ctlArray[i].replace(/\*.*/,"");
                ctlArray[i]=ctlArray[i].replace(/\#.*/,"");
             }
          for(var i=0; i<ctlArray.length; i++)
             {
                 if(ctlArray[i].match(/(speciestree =).*/g))
                    {
                        speciestree = ctlArray[i].match(/\d*\.*\d*/g).filter(function(v){return v.match(/\w+/g)!=null});
                    }
                if(ctlArray[i].match(/(speciesdelimitation =).*/g))
                    {
                        speciesdelim = ctlArray[i].match(/\d*\.*\d*/g).filter(function(v){return v.match(/\w+/g)!=null});
                        // alert(speciesdelim);
                    }
             }
             var blurb1="The analysis was conducted using the program BPP ";
             var blurb2="";
             if((speciestree[0] == 0)&&(speciesdelim[0] == 0))
                    blurb2="to infer ancestral thetas and divergence times (Rannala and Yang, 2003).";
             else
                if((speciestree[0] == 1)&&(speciesdelim[0] == 0))
                    blurb2="to infer ancestral thetas, divergence times and the species tree (Rannala and Yang, 2014). The proportion of SPR to nodeslider moves was " + speciestree[1] + ", the Expand ratio was " + speciestree[2] + " and the Shrink ratio was " + speciestree[3] + ". ";
                else
                    if((speciestree[0] == 1)&&(speciesdelim[0] == 1))
                        blurb2="to infer ancestral thetas, divergence times, species delimitations and the species tree (Rannala and Yang, 2014). The proportion of SPR to nodeslider moves was " + speciestree[1] + ", the Expand ratio was " + speciestree[2] + " and the Shrink ratio was " + speciestree[3] + ". " + " Species delimitation proposal algorithm " + speciesdelim[1] + " was used.";
                        else
                            if((speciestree[0] == 0)&&(speciesdelim[0] == 1))
                                blurb2="to infer ancestral thetas, divergence times and species delimitations using a guide tree (Rannala and Yang, 2010, 2013)."+ " Species delimitation proposal algorithm " + speciesdelim[1] + " was used.";
                var blurb3 = "This method accommodates the species phylogeny as well as incomplete lineage sorting due to ancestral polymorphism. A gamma prior G(2, 1000), with mean 2/2000 = 0.001, is used on the population size parameters (s). The age of the root in the species tree (0) is assigned the gamma prior G(2, 1000), while the other divergence time parameters are assigned the Dirichlet prior (Yang and Rannala, 2010: equation 2). Each analysis was run at least twice with different random number seeds and starting trees to confirm consistency between runs.";
         $( "#matmet" ).append(blurb1 + blurb2 + blurb3 + "\n");

        }
        catch(error)
        {
            alert(error.name + ": " + error.message);
        }
     });
});
}


getCtl2FilePath();

// functions for data provenance

var DPFilename="";
var dpfileOpen=false;

function addDataProvenance()
    {
        try{
        var seedUsed = 0;
        var ctrFileContents = "";
        seedUsed = fs.readFileSync('./SeedUsed');
        ctrFileContents = fs.readFileSync(ctlFilename);
        var v3=ctrFileContents.toString();
        var outPath="";
        v3=v3.match(/outfile(.*)/)[1].toString();
        console.log(v3);
        outPath=v3.match(/[^=\s]+/g).toString();

        var path = require('path');
        var outF = path.normalize(outPath)
        var outFileContents=fs.readFileSync(outPath);
        var v4=outFileContents.toString();
        if(v4.indexOf('Species in order')>0)
            var v5 = v4.substring(v4.indexOf('Species in order'),v4.length);
        else
            var v5 = v4.substring(v4.indexOf('(A) List of best models'),v4.length);
        $( "#dataprov" ).append(startTime.toLocaleString() + "\n");
        $( "#dataprov" ).append("Random seed: " + seedUsed);
        var secsElapsed = Math.round((endTime.getTime()-startTime.getTime())/1000);
        $( "#dataprov" ).append("CPU time: " + Math.floor(secsElapsed/60) +
                                " min: " +  secsElapsed % 60 + "sec. \n");
        $( "#dataprov" ).append(ctrFileContents + "\n");
        $( "#dataprov" ).append(v5 + "\n\n");
        if(dpfileOpen)
        {
            var DP1 = $( "#dataprov" ).val();
            fs.writeFile(DPFilename, DP1.toString(), function (err) {
            if (err) { return console.log(err); }
            });
        }
        }
        catch(error)
        {
            alert(error.name + ": " + error.message + "\n Are you sure control file is correct?");
        }
    }

$( "#addDPnote" ).click(function(evt) {
    var noteTime = new Date();
    $( "#dataprov" ).append("Note Added: " + noteTime.toLocaleString() + "\n" + $( "#dpNote" ).val()+ "\n");
    if(dpfileOpen)
    {
        var DP1 = $( "#dataprov" ).val();
        fs.writeFile(DPFilename, DP1.toString(), function (err) {
        if (err) { return console.log(err); }
        });
    }
});

var today = new Date().toDateString();
$( "#myDate" ).replaceWith("<p>" + today + "</p>");

function getDPFilePath(){
     $('#dataProvOut').change(function () {
         fs = require('fs');
         DPFilename=$('#dataProvOut').val();
         var DP1 = $( "#dataprov" ).val();
         fs.writeFile(DPFilename, DP1.toString(), function (err) {
         if (err) { return console.log(err); }
         else
             dpfileOpen=true;
    });
});
}

getDPFilePath();

});
