/* functions for generating configuration file */

// global variables for ctrl file configuration

var CFstring = "";
var seqfile = "empty";
var Imapfile = "empty";
var treefile = "empty";
var outfile = "empty";
var mcmcfile = "empty";
var ctlOutFileNm="";
var ctl2Filename="";
var ctlFilename
var spDel=0;
var stInf=0;
var sDelPropAlg=0;
var rndSeed=0;
var rtMean=0.001;
var rtVar=0.001;
var thetaMean=0.001;
var thetaVar=0.001;
var hsMean=0.001;
var hsVar=0.001;
var treePrior="urtrees";
var rtGammaParm = {};
rtGammaParm.alpha=0;
rtGammaParm.beta=0;
var thetaGammaParm = {};
thetaGammaParm.alpha=0;
thetaGammaParm.beta=0;
var hsGammaParm = {};
hsGammaParm.alpha=0;
hsGammaParm.beta=0;
var GBtjMix=0.10;
var GBsprMix=0.10;
var thetaMix=0.10;
var tauMix=0.10;
var mixMix=0.10;
var locusrateMix=0.10;
var seqerrMix=0.10;
var autoBool=1;
var likelihoodBool=1;
var printSTBool=1;
var printGTBool=0;
var printLRBool=0;
var printHSBool=0;
var ambiguityBool=0;
var locusrate=0;
var heredity=0;
var popNames=[];
var maxSeqs=[];
var nspecies=0;
var popNameStr="species&tree = empty \n empty \n empty \n";
var popN=[];
var ctlString="";
var ctlArray=[];
var byLines=[];

// functions for ctrl file configuration

var didReadMapFile=true;

function getImapFilePath(){
     $('#inputimap').change(function () {
         popN=[];
         didReadMapFile=true;
         Imapfile=$('#inputimap').val();
         var popCounts={};
         var e2;
         
         fs.readFile(Imapfile, 'utf-8', function (error, contents) {
         var seqString = contents;
         byLines=seqString.split("\n");
         for(var i4=0; i4<byLines.length; i4++)
             byLines[i4]=byLines[i4].replace(/\/\/.*/,"");
         byLines=byLines.filter(function(v){return v.match(/\w+/g)!=null});
         // alert(byLines);
         for(var i3=0; i3<byLines.length; i3++)
         {
                e2=byLines[i3].match(/\w+/g)[1];
                   if(popCounts[e2]==undefined)
                    {
                        popCounts[e2]=1;
                        popN.push(e2);
                    }
                    else
                    {
                        popCounts[e2]+=1;  
                    }
         }   
         if(didReadMapFile)
         {
            popNameStr="species&tree = " + popN.length;
            for(var j=0; j<popN.length; j++)
                popNameStr += "   " + popN[j];
            popNameStr += "\n                   ";
            for(var j=0; j<popN.length; j++)
                popNameStr +=popCounts[popN[j]]+ "    ";
            popNameStr += "\n";
            fillControlFile();
            $("#mfile").val(Imapfile);
            if((seqfile != "empty")&&(treefile != "empty")&&(outfile != "empty")&&(mcmcfile != "empty"))
                {$( "#fileWarn" ).addClass('not'); $( "#savectrlfile" ).removeClass('not');}
         }
         
         });
     });
}


function getSeqFilePath(){
     $('#inputseq').change(function () {
         seqfile=$('#inputseq').val();

         fs.readFile(seqfile, 'utf-8', function (error, contents) {
         try{
         if(error) throw error;
         var seqString = contents;
         if((seqString.match(/(\s+\d+)|(^\d+)/g)==null)||(seqString.substring(0,22).match(/(\s+\d+)|(^\d+)/g).length!=2))  // there are no loci
         {
            throw {name: 'readFile Error', message: 'Not a BPP sequence data file?'};
         }
         else
         {
            nloci = (seqString.match(/(\s+\d+)|(^\d+)/g).length)/2   // each initial line for a locus has 2 integer numbers = nloci*2
            fillControlFile();
            $("#sfile").val(seqfile);
            if((seqfile != "empty")&&(treefile != "empty")&&(outfile != "empty")&&(mcmcfile != "empty"))
                {$( "#fileWarn" ).addClass('not'); $( "#savectrlfile" ).removeClass('not');}
         }
         }
         catch(error)
         {
            alert(error.name + ": " + error.message);
         }
        });
    });
}

function getMCMCFilePath(){
     $('#outputmcmcfile').change(function () {
         mcmcfile=$('#outputmcmcfile').val();
            if((seqfile != "empty")&&(treefile != "empty")&&(outfile != "empty")&&(mcmcfile != "empty"))
                {$( "#fileWarn" ).addClass('not'); $( "#savectrlfile" ).removeClass('not');}
         fillControlFile();
         $("#mcfile").val(mcmcfile);
     });
}

function getOutFilePath(){
     $('#outputresultsfile').change(function () {
         outfile=$('#outputresultsfile').val();
            if((seqfile != "empty")&&(treefile != "empty")&&(outfile != "empty")&&(mcmcfile != "empty"))
                {$( "#fileWarn" ).addClass('not'); $( "#savectrlfile" ).removeClass('not');}
         fillControlFile();
         $("#ofile").val(outfile);
     });
}

function getTreeFilePath(){
     $('#importtree').change(function () {
         treefile=$('#importtree').val();
         fs.readFile(treefile, 'utf-8', function (error, contents) {
         treeString = contents;
         nspecies = 1 + treeString.match(/,/g).length;  // number of ',' = nspecies -1
         fillControlFile();
        if((Imapfile != "empty")&&(seqfile != "empty")) { $( "#fileWarn" ).addClass('not'); $( "#savectrlfile" ).removeClass('not'); }
         });
       });
}

function getCtlFile(){
     $('#ctlimport').change(function () {
         var ctlfile=$('#ctlimport').val();
         fs.readFile(ctlfile, 'utf-8', function (error, contents) {
         try{
         if(error) throw error;
         ctlString = contents;
         ctlArray=ctlString.match(/[^\r\n]+/g);
         for(var i=0; i<ctlArray.length; i++)
             {
                ctlArray[i]=ctlArray[i].replace(/\*.*/,"");
                ctlArray[i]=ctlArray[i].replace(/\#.*/,"");
             }
         for(var i=0; i<ctlArray.length; i++)
             {
                 if(ctlArray[i].match(/seed/)!=null)
                     {
                        $( "#seed" ).spinner( "value", ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'') );
                     }
                 if(ctlArray[i].match(/seqfile/)!=null)
                     {
                         seqfile=ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'');
                         $("#sfile").val(seqfile);
                      }
                 if(ctlArray[i].match(/Imapfile/)!=null)
                     {
                         Imapfile=ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'');
                         $("#mfile").val(Imapfile);
                     }
                if(ctlArray[i].match(/outfile/)!=null)
                     {
                         outfile=ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'');
                         $("#ofile").val(outfile);
                     }
                if(ctlArray[i].match(/mcmcfile/)!=null)
                     {
                         mcmcfile=ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'');
                         $("#mcfile").val(mcmcfile);
                     }
                 if(ctlArray[i].match(/speciestree/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==1)
                             {
                                 stInf=1;
                                 $( "#stInfer" ).val("stinf");
                                 $( "#pSlider" ).val(tmpArray[1]);
                                 $( "#expRatio" ).val(tmpArray[2]);
                                 $( "#shrRatio" ).val(tmpArray[3]);
                                 $( "#stimix" ).removeClass('not');
                                 $( "#stInfer" ).selectmenu("refresh");                     
                             }
                         else
                             {
                                 stInf=0;
                                 $( "#stInfer" ).val("nostinf");
                                 $( "#stimix" ).addClass('not');
                                 $( "#stInfer" ).selectmenu("refresh");       
                             }
                        }
                 if(ctlArray[i].match(/speciesdelimitation/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==1)
                             {
                                 spDel=1;                             
                                 $( "#spDelim" ).val("spdel");
                                 $( "#sdmix" ).removeClass('not');
                                 $( "#spDelim" ).selectmenu("refresh");
                                  if(tmpArray.length==3)
                                    {
                                    sDelPropAlg=0;
                                    $( "#delprop1" ).attr("checked",true);
                                    $( "#delprop2" ).attr("checked",false);
                                    $( "#delprop" ).buttonset();
                                    $( "#dp1p" ).val(tmpArray[2]);
                                    $( "#dp1parms" ).removeClass('not');
                                    $( "#dp2parms" ).addClass('not');
                                    }
                                 if(tmpArray.length==4)
                                    {
                                    sDelPropAlg=1;
                                    $( "#delprop1" ).attr("checked",false);
                                    $( "#delprop2" ).attr("checked",true);
                                    $( "#delprop" ).buttonset();
                                    $( "#dp2p_a" ).val(tmpArray[2]);
                                    $( "#dp2p_m" ).val(tmpArray[3]); 
                                    $( "#dp2parms" ).removeClass('not');
                                    $( "#dp1parms" ).addClass('not');
                                    }

                              }
                         else
                             {
                                 spDel=0;
                                 $( "#spDelim" ).val("nospdel");
                                 $( "#sdmix" ).addClass('not');
                                 $( "#spDelim" ).selectmenu("refresh");       
                             }
                        }
                    if(ctlArray[i].match(/species&tree/)!=null)
                        {
                         popNameStr=ctlArray[i] + "\n" + ctlArray[i+1] + "\n";
                         treeString=ctlArray[i+2];
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         popN = tmp1.match(/[^\s]+/g);
                         popN.shift();
                        }
                    if(ctlArray[i].match(/usedata/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]=="0")
                             {
                             likelihoodBool=0;
                             $( "#uselikelihood" ).attr("checked",false);
                             }
                         else
                             {
                             likelihoodBool=1;
                             $( "#uselikelihood" ).attr("checked",true);
                             }

                     }
                    if(ctlArray[i].match(/nloci/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         nloci=tmpArray[0];
                     }
                    if(ctlArray[i].match(/burnin/)!=null)
                     {
                         $( "#burnin" ).spinner( "value", ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'') );
                     }
                     if(ctlArray[i].match(/sampfreq/)!=null)
                     {
                         $( "#sampling" ).spinner( "value", ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'') );
                     }
                     if(ctlArray[i].match(/nsample/)!=null)
                     {
                         $( "#replicates" ).spinner( "value", ctlArray[i].replace(/^.+=/,'').replace(/(^\s+|\s+$)/g,'') );
                     }
                     if(ctlArray[i].match(/thetaprior/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         thetaGammaParm.alpha=parseFloat(tmpArray[0]);
                         thetaGammaParm.beta=parseFloat(tmpArray[1]);
                         thetaMean=thetaGammaParm.alpha/thetaGammaParm.beta;
                         thetaVar=thetaGammaParm.alpha/(thetaGammaParm.beta*thetaGammaParm.beta);
                         $( "#thetaMean" ).val(thetaMean);
                         $( "#thetaVar" ).val(thetaVar);
                     }
                     if(ctlArray[i].match(/tauprior/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'');
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         rtGammaParm.alpha=parseFloat(tmpArray[0]);
                         rtGammaParm.beta=parseFloat(tmpArray[1]);
                         rtMean=rtGammaParm.alpha/rtGammaParm.beta;
                         rtVar=rtGammaParm.alpha/(rtGammaParm.beta*rtGammaParm.beta);
                         $( "#rootMean" ).val(rtMean);
                         $( "#rootVar" ).val(rtVar);
                         $( "#dirAlpha" ).val(parseFloat(tmpArray[2]));
                     }
                    if(ctlArray[i].match(/speciesmodelprior/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'');
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==0)
                             treePrior="uhistory";
                         else
                             if(tmpArray[0]==1)
                                 treePrior="urtrees";
                             else
                                 if(tmpArray[0]==2)
                                     treePrior="ushistory";
                                 else
                                     treePrior="urstrees";
                     }
                    if(ctlArray[i].match(/finetune/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]=="1:")
                             {
                                 autoBool=1;
                                 $( "#autotune" ).attr("checked",true);
                             }
                         else
                             {
                                 autoBool=0;
                                 $( "#autotune" ).attr("checked",false);                              
                             }
                      for(var j=1; j<tmpArray.length; j++)
                             {
                                 if(j==1)
                                     {
                                         GBtjMix=parseFloat(tmpArray[j]);
                                         $( "#GBtjMix" ).val(GBtjMix);
                                     }
                                 if(j==2)
                                     {
                                         GBsprMix=parseFloat(tmpArray[j]);
                                         $( "#GBsprMix" ).val(GBsprMix);
                                     }
                                 if(j==3)
                                     {
                                         thetaMix=parseFloat(tmpArray[j]);
                                         $( "#thetaMix" ).val(thetaMix);
                                     }
                                 if(j==4)
                                     {
                                         tauMix=parseFloat(tmpArray[j]);
                                         $( "#tauMix" ).val(tauMix);
                                     }
                                 if(j==5)
                                     {
                                         mixMix=parseFloat(tmpArray[j]);
                                         $( "#mixMix" ).val(mixMix);
                                     }
                                 if(j==6)
                                     {
                                         locusrateMix=parseFloat(tmpArray[j]);
                                         $( "#locusrateMix" ).val(locusrateMix);
                                     }
                                 if(j==7)
                                     {
                                         seqerrMix=parseFloat(tmpArray[j]);
                                         $( "#seqerrMix" ).val(seqerrMix);
                                     }                                 
                             }
                         
                     }
                     if(ctlArray[i].match(/cleandata/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==0)
                             {
                                 ambiguityBool=0;
                                 $( "#ambiguity" ).attr("checked",false);
                             }
                         else
                             {
                                 ambiguityBool=1;
                                 $( "#ambiguity" ).attr("checked",true);
                             }
                     }
                     if(ctlArray[i].match(/locusrate/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==0)
                             {
                                locusrate=0;
                                $( "#locusratesprior" ).addClass('not');
                                $( "#locusRates" ).val("equalRates");
                                $( "#locusRates" ).selectmenu("refresh"); 
                             }
                         if(tmpArray[0]==1)
                             {
                                locusrate=1;
                                $( "#locusratesprior" ).removeClass('not');
                                $( "#locusRatesAlpha" ).val(parseFloat(tmpArray[1]));
                                $( "#locusRates" ).val("estimateRates");
                                $( "#locusRates" ).selectmenu("refresh"); 
                             }
                        if(tmpArray[0]==2)
                             {
                                locusrate=2;
                                $( "#locusratesprior" ).addClass('not');
                                $( "#locusRates" ).val("specRates");
                                $( "#locusRates" ).selectmenu("refresh");
                             }

                     }
                    if(ctlArray[i].match(/heredity/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==0)
                             {
                                heredity=0;
                                $( "#heredityscalarsprior" ).addClass('not');
                                $( "#heredScalars" ).val("equalScalars");
                                $( "#heredScalars" ).selectmenu("refresh"); 
                             }
                         if(tmpArray[0]==1)
                             {
                                heredity=1;
                                $( "#heredityscalarsprior" ).removeClass('not');
                                hsGammaParm.alpha=parseFloat(tmpArray[1]);
                                hsGammaParm.beta=parseFloat(tmpArray[2]);
                                hsMean=hsGammaParm.alpha/hsGammaParm.beta;
                                hsVar=hsGammaParm.alpha/(hsGammaParm.beta*hsGammaParm.beta);
                                $( "#hsMean" ).val(hsMean);
                                $( "#hsVar" ).val(hsVar);
                                $( "#heredScalars" ).val("estimateScalars");
                                $( "#heredScalars" ).selectmenu("refresh"); 
                             }
                        if(tmpArray[0]==2)
                             {
                                heredity=2;
                                $( "#heredityscalarsprior" ).addClass('not');
                                $( "#heredScalars" ).val("specScalars");
                                $( "#heredScalars" ).selectmenu("refresh");
                             }
                     }
                     if(ctlArray[i].match(/print/)!=null)
                     {
                         var tmp1=ctlArray[i].replace(/^.+=/,'')
                         var tmpArray=tmp1.match(/[^\s]+/g);
                         if(tmpArray[0]==0)
                             {
                                 printSTBool=0;
                                 $( "#printstrees" ).attr("checked",false);
                             }
                         else
                             {
                                 printSTBool=1;
                                 $( "#printstrees" ).attr("checked",true);
                             }
                         if(tmpArray[1]==0)
                             {
                                 printLRBool=0;
                                 $( "#printlocusrates" ).attr("checked",false);
                             }
                         else
                            {
                                 printLRBool=1;
                                 $( "#printlocusrates" ).attr("checked",true);
                            }
                        if(tmpArray[2]==0)
                             {
                                 printHSBool=0;
                                 $( "#printhscalars" ).attr("checked",false);
                             }
                         else
                            {
                                 printHSBool=1;
                                 $( "#printhscalars" ).attr("checked",true);
                            }
                       if(tmpArray[3]==0)
                             {
                                 printGTBool=0;
                                 $( "#printgtrees" ).attr("checked",false);
                             }
                         else
                            {
                                 printGTBool=1;
                                 $( "#printgtrees" ).attr("checked",true);
                            }


                     }
                 
             }
              if((stInf==1)&&(spDel==1))
                  {
                      $( "#topologyprior" ).removeClass('not');
                      $( "#userprobs" ).addClass('not');
                      $( "#nouserprobs" ).removeClass('not');
                      $( "#topolPrior2" ).val(treePrior);
                       $( "#topolPrior2" ).selectmenu("refresh");
                  }
              else
                  if(((stInf==1)&&(spDel==0))||((stInf==0)&&(spDel==1)))
                      {
                      $( "#topologyprior" ).removeClass('not');
                      $( "#userprobs" ).removeClass('not');
                      $( "#nouserprobs" ).addClass('not');
                      $( "#topolPrior2" ).val(treePrior);
                      $( "#topolPrior2" ).selectmenu("refresh");                              
                      }
              if((seqfile != "empty")&&(treefile != "empty")&&(outfile != "empty")&&(mcmcfile != "empty"))
                {$( "#fileWarn" ).addClass('not'); $( "#savectrlfile" ).removeClass('not');}
              fillControlFile();
         }
         catch(error)
         {
            alert(error.name + ": " + error.message);
         }
        }); 
    }); 
}


getImapFilePath();
getSeqFilePath();
getMCMCFilePath();
getOutFilePath();
getTreeFilePath();
getCtlFile();

function fillControlFile() {
if((treeString!="empty")&&(seqfile!="empty")&&(Imapfile!="empty"))
{
    $( "#fileWarn" ).addClass('not');
    $( "#savectrlfile" ).removeClass('not');
}
if($( "#seed" ).spinner( "value" )==0)
    CFstring = "seed = -1 \n";
else
    CFstring = "seed = " + $( "#seed" ).spinner( "value" ) + "\n";
CFstring += "seqfile = " + seqfile + "\n";
CFstring += "Imapfile = " + Imapfile + "\n";
CFstring += "outfile = " + outfile + "\n";
CFstring += "mcmcfile = " + mcmcfile + "\n";
if(spDel==0)
    CFstring += "speciesdelimitation = 0 \n";
else
    {
        CFstring += "speciesdelimitation = 1";
            if(sDelPropAlg==0)
                CFstring += " 0 " + $( "#dp1p" ).val() + "\n";
            else
                CFstring += " 1 " + $( "#dp2p_a" ).val() + " " + $( "#dp2p_m" ).val() + "\n";
    }
if(stInf==0)
    CFstring += "speciestree = 0 \n";
else
    {
    CFstring += "speciestree = 1 ";
        CFstring += $( "#pSlider" ).val() + " " + $( "#expRatio" ).val() + " " + $( "#shrRatio" ).val() + "\n";
        
    }
if((stInf==1)||(spDel==1))
{
    if(treePrior=="uhistory")
        CFstring += "speciesmodelprior = 0 \n";
    else
        if(treePrior=="urtrees")
            CFstring += "speciesmodelprior = 1 \n";
        else
            if(treePrior=="urstrees")
                CFstring += "speciesmodelprior = 3 \n";
            else
                if(treePrior=="ushistory")
                    CFstring += "speciesmodelprior = 2 \n";
}

CFstring += popNameStr;
CFstring += treeString + " \n";
CFstring += "usedata = " + likelihoodBool + "\n";
CFstring += "nloci = " + nloci + "\n";
CFstring += "cleandata = " + ambiguityBool + "\n";
CFstring += "thetaprior = " + thetaGammaParm.alpha.toFixed(4) + " " + thetaGammaParm.beta.toFixed(4) + "\n";
CFstring += "tauprior = " + rtGammaParm.alpha.toFixed(4) + " " + rtGammaParm.beta.toFixed(4) + " " + $( "#dirAlpha" ).val() + "\n";
CFstring += "locusrate = " + locusrate;
if(locusrate==1) { CFstring += " " + $( "#locusRatesAlpha" ).val() + "\n"; } else { CFstring += "\n"; }
CFstring += "heredity = " + heredity;
if(heredity==1) { CFstring += " " + hsGammaParm.alpha + " " + hsGammaParm.beta + "\n"; } else { CFstring += "\n"; }    
CFstring += "finetune = " + autoBool +": " + GBtjMix +" " + GBsprMix + " " + thetaMix + " " + tauMix + " " + mixMix + " " +locusrateMix + " " + seqerrMix + "\n";
CFstring += "print = " + printSTBool + " " + printLRBool + " " + printHSBool + " " + printGTBool + "\n";
CFstring += "burnin = " + $( "#burnin" ).spinner( "value" ) + "\n";
CFstring += "sampfreq = " + $( "#sampling" ).spinner( "value" ) + "\n";
CFstring += "nsample = " + $( "#replicates" ).spinner( "value" ) + "\n";
$( "#cfile" ).val(CFstring);
}

function bppCtlOutFile(){
     $( "#ctlout" ).change(function () {
         ctlOutFileNm=$('#ctlout').val();
         fs.writeFile(ctlOutFileNm, CFstring, function (err) {
         if (err) return console.log(err);
         });
});
}

bppCtlOutFile();


function convertToGamma(gammaParm, mean, variance)
{
        gammaParm.alpha = (mean*mean)/variance;
        gammaParm.beta = mean/variance;
}

$( "#delprop" ).buttonset()
$( "#dp1p" ).val("2.5");
$( "#dp2p_a" ).val("2");
$( "#dp2p_m" ).val("1");

$( "#delprop1" ).click(function() {
   $( "#dp1parms" ).removeClass("not");
   $( "#dp2parms" ).addClass("not");
   $( "#dp1p" ).val("2.5");
   sDelPropAlg=0;
   fillControlFile();
});

$( "#delprop2" ).click(function() {
   $( "#dp2parms" ).removeClass("not");
   $( "#dp1parms" ).addClass("not");
   $( "#dp2p_a" ).val("2");
   $( "#dp2p_m" ).val("1");
   sDelPropAlg=1;
   fillControlFile();
});

$( "#dp1p" ).change(function() {
   fillControlFile();
});

$( "#dp2p_a" ).change(function() {
   fillControlFile();
});

$( "#dp2p_m" ).change(function() {
   fillControlFile();
});

$( "#gentree" ).button()

$( "#gentree" ).click(function() {
    if(Imapfile!="empty")
    {
        treeString="                   ";
        var rTree = randomTree(popN);
        treeString += newickFromTree(rTree);
        treeString += ";";
        fillControlFile();
    }
    else
        alert("Must specify individual to population map \n file before random starting tree is generated!");
});

$( "#ambiguity" ).on("click",function() {
    if(ambiguityBool)
        ambiguityBool=0;
    else
        ambiguityBool=1;
    fillControlFile();
});


$( "#uselikelihood" ).on("click",function() {
    if(likelihoodBool)
        likelihoodBool=0;
    else
        likelihoodBool=1;
    fillControlFile();
});

$( "#printstrees" ).on("click",function() {
    if(printSTBool)
        printSTBool=0;
    else
        printSTBool=1;
    fillControlFile();
});

$( "#printgtrees" ).on("click",function() {
    if(printGTBool)
        printGTBool=0;
    else
        printGTBool=1;
    fillControlFile();
});

$( "#printlocusrates" ).on("click",function() {
    if(printLRBool)
        printLRBool=0;
    else
        printLRBool=1;
    fillControlFile();
});

$( "#printhscalars" ).on("click",function() {
    if(printHSBool)
        printHSBool=0;
    else
        printHSBool=1;
    fillControlFile();
});


$( "#autotune" ).on("click",function() {
    if(autoBool)
        autoBool=0;
    else
        autoBool=1;
    fillControlFile();
});

function assertPos(className,defaultVal)
{
    if (!($( className ).val()>0))
    {
        alert("Must be a positive number!");
        $( className ).val(defaultVal);
        return false;
    }
    else
        return true;
}

$( "#GBtjMix" ).text()
$( "#GBtjMix" ).val("0.10")
$( "#GBtjMix" ).change(function() {
    if(assertPos("#GBtjMix","0.10"))
    {
        GBtjMix=$( "#GBtjMix" ).val();
        fillControlFile();
    }
});

$( "#GBsprMix" ).text()
$( "#GBsprMix" ).val("0.10")
$( "#GBsprMix" ).change(function() {
    if(assertPos("#GBsprMix","0.10"))
    {
        GBsprMix=$( "#GBsprMix" ).val();
        fillControlFile();
    }
});

$( "#thetaMix" ).text()
$( "#thetaMix" ).val("0.10")
$( "#thetaMix" ).change(function() {
    if(assertPos("#thetaMix","0.10"))
    {
        thetaMix=$( "#thetaMix" ).val();
        fillControlFile();
    }
});

 $( "#tauMix" ).text()
$( "#tauMix" ).val("0.10")
$( "#tauMix" ).change(function() {
    if(assertPos("#tauMix","0.10"))
    {
        tauMix=$( "#tauMix" ).val();
        fillControlFile();
    }
});

$( "#mixMix" ).text()
$( "#mixMix" ).val("0.10")
$( "#mixMix" ).change(function() {
    if(assertPos("#mixMix","0.10"))
    {
        mixMix=$( "#mixMix" ).val();
        fillControlFile();
    }
});

$( "#locusrateMix" ).text()
$( "#locusrateMix" ).val("0.10")
$( "#locusrateMix" ).change(function() {
    if(assertPos("#locusrateMix","0.10"))
    {
        locusrateMix=$( "#locusrateMix" ).val();
        fillControlFile();
    }
});

$( "#seqerrMix" ).text()
$( "#seqerrMix" ).val("0.10")
$( "#seqerrMix" ).change(function() {
    if(assertPos("#seqerrMix","0.10"))
    {
        seqerrMix=$( "#seqerrMix" ).val();
        fillControlFile();
    }
});

$( "#rootMean" ).text()
$( "#rootMean" ).val("0.001")
$( "#rootMean" ).change(function() {
    if(assertPos("#rootMean","0.001"))
    {
        rtMean=$( "#rootMean" ).val();
        convertToGamma(rtGammaParm,$( "#rootMean" ).val(),$( "#rootVar" ).val());
        fillControlFile();
    }
});

$( "#rootVar" ).text()
$( "#rootVar" ).val("0.000001")
$( "#rootVar" ).change(function() {
    if(assertPos("#rootVar","0.000001"))
    {
        rtVar=$( "#rootVar" ).val();
        convertToGamma(rtGammaParm,$( "#rootMean" ).val(),$( "#rootVar" ).val());
        fillControlFile();
    }
});

$( "#dirAlpha" ).text()
$( "#dirAlpha" ).val("1")
$( "#dirAlpha" ).change(function() {
    if(assertPos("#dirAlpha","1"))
    {
        fillControlFile();
    }
});

$( "#locusRatesAlpha" ).text()
$( "#locusRatesAlpha" ).val("1")
$( "#locusRatesAlpha" ).change(function() {
    if(assertPos("#locusRatesAlpha","1"))
    {
        fillControlFile();
    }
});

$( "#hsMean" ).text()
$( "#hsMean" ).val("0.001")
$( "#hsMean" ).change(function() {
    if(assertPos("#hsMean","0.001"))
    {
        hsMean=$( "#hsMean" ).val();
        convertToGamma(hsGammaParm,$( "#hsMean" ).val(),$( "#hsVar" ).val());
        fillControlFile();
    }
});

$( "#hsVar" ).text()
$( "#hsVar" ).val("0.000001")
$( "#hsVar" ).change(function() {
    if(assertPos("#hsVar","0.000001"))
    {
        hsVar=$( "#hsVar" ).val();
        convertToGamma(hsGammaParm,$( "#hsMean" ).val(),$( "#hsVar" ).val());
        fillControlFile();
    }
});

convertToGamma(hsGammaParm,$( "#hsMean" ).val(),$( "#hsVar" ).val());
convertToGamma(rtGammaParm,$( "#rootMean" ).val(),$( "#rootVar" ).val());

$( "#thetaMean" ).text()
$( "#thetaMean" ).val("0.001")
$( "#thetaMean" ).change(function() {
    if(assertPos("#thetaMean","0.001"))
    {
        thetaMean=$( "#thetaMean" ).val();
        convertToGamma(thetaGammaParm,$( "#thetaMean" ).val(),$( "#thetaVar" ).val());
        fillControlFile();
    }
});

$( "#thetaVar" ).text()
$( "#thetaVar" ).val("0.000001")
$( "#thetaVar" ).change(function() {
    if(assertPos("#thetaVar","0.000001"))
    {
        thetaVar=$( "#thetaVar" ).val();
        convertToGamma(thetaGammaParm,$( "#thetaMean" ).val(),$( "#thetaVar" ).val());
        fillControlFile();
    }
});

convertToGamma(thetaGammaParm,$( "#thetaMean" ).val(),$( "#thetaVar" ).val());

$( "#burnin" ).spinner({
    min: 0,
    step: 1000
});

$( "#burnin" ).spinner( "value", 5000 );

$( "#burnin" ).on( "spinchange", function() {
fillControlFile();
} );

$( "#replicates" ).spinner({
    min: 0,
    step: 1000
});

$( "#replicates" ).spinner( "value", 50000 );

$( "#replicates" ).on( "spinchange", function() {
fillControlFile();
} );

$( "#sampling" ).spinner({
    min: 1,
    max:10000,
    step: 1
});

$( "#sampling" ).spinner( "value", 5 );

$( "#sampling" ).on( "spinchange", function() {
fillControlFile();
} );


$( "#accordion" ).accordion();


$( "#menu" ).menu();

$( "#spDelim" ).selectmenu();

$( "#spDelim" ).on( "selectmenuchange", function() {
  $( "#spDelim" ).val()=="spdel" ? spDel=1 : spDel=0;
  if(spDel==1)
      $( "#sdmix" ).removeClass('not');
    else
      $( "#sdmix" ).addClass('not');
  if((stInf==0)&&(spDel==0))
      $( "#topologyprior" ).addClass('not');
  else
      $( "#topologyprior" ).removeClass('not');
  if(!((spDel==1)&&(stInf==1)))
      {
        $( "#nouserprobs" ).addClass('not');
        $( "#userprobs" ).removeClass('not');
       }
  else
      {
        $( "#nouserprobs" ).removeClass('not');
        $( "#userprobs" ).addClass('not');
       }
  fillControlFile();
});


$( "#seed" ).spinner({ min:0 });
$( "#seed" ).spinner( "value", 0 );

$( "#seed" ).on( "spinchange", function() {
rndSeed = $( "#seed" ).spinner( "value" );
fillControlFile();
} );

$( "#stInfer" ).selectmenu();

$( "#stInfer" ).on( "selectmenuchange", function() {
  $( "#stInfer" ).val()=="stinf" ? stInf=1 : stInf=0;
  if(stInf==1) 
    { 
        $( "#pSlider" ).val("0.40");
        $( "#expRatio" ).val("0.10");
        $( "#shrRatio" ).val("0.10");
        $( "#stimix" ).removeClass('not');
    }
    else { $( "#stimix" ).addClass('not');}
  if((stInf==0)&&(spDel==0))
      $( "#topologyprior" ).addClass('not');
  else
      $( "#topologyprior" ).removeClass('not');
  if(!((spDel==1)&&(stInf==1)))
      {
        $( "#nouserprobs" ).addClass('not');
        $( "#userprobs" ).removeClass('not');
      }
      else
      {
        $( "#nouserprobs" ).removeClass('not');
        $( "#userprobs" ).addClass('not');

      }
     fillControlFile();
});

$( "#locusRates" ).selectmenu();

$( "#locusRates" ).on( "selectmenuchange", function() {
if($( "#locusRates" ).val()=="equalRates")
    {
        locusrate=0;
        $( "#locusratesprior" ).addClass('not');
    }
else
    if($( "#locusRates" ).val()=="estimateRates")
        {
            locusrate=1;
            $( "#locusratesprior" ).removeClass('not');
        }
    else
       if($( "#locusRates" ).val()=="specRates")
        {
            locusrate=2;
            $( "#locusratesprior" ).addClass('not');
        }
    fillControlFile();
});

$( "#heredScalars" ).selectmenu();

$( "#heredScalars" ).on( "selectmenuchange", function() {
if($( "#heredScalars" ).val()=="equalScalars")
    {
        heredity=0;
        $( "#heredityscalarsprior" ).addClass('not');
    }
else
    if($( "#heredScalars" ).val()=="estimateScalars")
    {
        heredity=1;
        $( "#heredityscalarsprior" ).removeClass('not');
    }
    else
        if($( "#heredScalars" ).val()=="specScalars")
        {
            heredity=2;
            $( "#heredityscalarsprior" ).addClass('not');
        }
    fillControlFile();
});


$( "#pSlider" ).change(function() {
    if(assertPos("#pSlider","0.40"))
    {
        pSlider=$( "#pSlider" ).val();
        fillControlFile();
    }
});

$( "#expRatio" ).change(function() {
    if(assertPos("#expRatio","0.10"))
    {
        expRatio=$( "#expRatio" ).val();
        fillControlFile();
    }
});

$( "#shrRatio" ).change(function() {
    if(assertPos("#shrRatio","0.10"))
    {
        pSlider=$( "#shrRatio" ).val();
        fillControlFile();
    }
});

$( "#topolPrior1" ).selectmenu();

$( "#topolPrior1" ).on( "selectmenuchange", function() {
    treePrior = $( "#topolPrior1" ).val();
    fillControlFile();
});

$( "#topolPrior2" ).selectmenu();

$( "#topolPrior2" ).on( "selectmenuchange", function() {
    treePrior = $( "#topolPrior2" ).val();
    fillControlFile();
});
